"use strict";
window.Thread=class {
    constructor() {
        this.waitTime=0;
        this.onends=[];
        this.__scheduler=Tonyu.globals.$Scheduler;
    }
    apply(obj, methodName, args) {
        args=args||[];
        this.it=obj[methodName].apply(obj,args);    
    }
    addToNext() {
        if (this._obj && this._obj.isDead()) return;
        this.__scheduler.addToNext(this);
    }
    on(type,func) {
        if (type=="end") {
            this.onends.push(func);
        }
    }
    steps() {
        if ((this.waitTime--)>0) {
            this.addToNext();
            return;
        }
        var y=this.it.next();
        if (y.done) {
            this.onends.forEach(function(f){f()});            
        } else if (y.value==null) {
            this.addToNext();
        } else if (typeof y.value=="number") {
            this.waitTime=y.value;
            this.addToNext();
        }
    }
};
window.Actor = class extends Tonyu.classes.kernel.Actor {
    constructor(p) {
        super(p);  
        var th=new window.Thread;
        th._obj=this;
        th.apply(this,"main");
        th.steps();
        if ($Screen) {
            $Screen.setPivot($screenWidth/2,$screenHeight/2);
            $Screen.scrollTo($screenWidth/2,$screenHeight/2);
        }
        //th.on("die",function() {th.kill();});
    }
    *main() {
    }
};
window.Label = Tonyu.classes.kernel.Label;
window.BodyActor = class extends Tonyu.classes.kernel.BodyActor {
    constructor(p) {
        super(p);  
        var th=new window.Thread;
        th._obj=this;
        th.apply(this,"main");
        th.steps();
    }
    *main() {
    }
};
window.Button=class extends Tonyu.classes.kernel.Button {
};

function setMain(c) {
	Tonyu.classes.user=Tonyu.classes.user||{};
	Tonyu.classes.user.Main=c;
}
